
//	Copyright 2010 PaletteSoft LLC

//	******  ******* *     * *******  *****  *******                           
//	*     * *       *     *    *    *     * *                                 
//	*     * *       *     *    *    *       *                                 
//	*     * ******* *     *    *    *       *******                           
//	*     * *        *   *     *    *       *                                 
//	*     * *         * *      *    *     * *                                 
//	******  *******    *    *******  *****  *******                           

// ===========================================================================
// =	CL^															 =
// ===========================================================================
//	002 2010.??.??
//	E
// ---------------------------------------------------------------------------
//	001 2010.05.16
//	EVK쐬@PIC 16F886 3.3V 쓮pɕύX@by@A.Ohta
// ===========================================================================

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************
// ***************************************************************************

	//	*****  *****

#include	<pic.h>														//	vWFNgݒőIꂽfoCXIɈp܂

	//	***** 錾 *****

#include	"_AtrDef.h"													//	萔Af[^^̐錾

	//	*****  *****

#include	"version.h"													//	o[Wԍ̒`

#include	"device.h"													//	foCX

#include	"nokiaGlcdlib.h"											//  LCD				ǉ
// ***************************************************************************
// *	zdl															 *
// ***************************************************************************
/*
	CZT]TvvO		PIC16F886 CLOCK:8MHz Vdd = 3.3V
	ӁFdd̍ő͂RDRu܂		SCP1000-D01	High resolution mode

	RA0:MOSI	PIC -> SCP	Mf[^										ύX
	RA1:SCK		PIC -> SCP	NbN										ύX
	RA2:SW1		㉟{^SW											ύXAǉ
	RA3:MISO	PIC <- SCP	Mf[^										ύX
	RA4:CSB		PIC -> SCP	`bvZNg									ύX
	RA5:TXD		PIC -> ext	VAʐMMf[^iVCCxj			ύX

	RB0:DRDY	PIC <- SCP	f[^ZbgiオGbWO INT0 𗘗pj		ǉ

	RC0:(INV)SCE	PIC -> GLCD	(INV)`bvZNg							ǉ
	RC1:SDIN		PIC -> GLCD	Mf[^									ǉ
	RC2:SLCK		PIC -> GLCD	NbN									ǉ
	RC3:D/C			PIC -> GLCD	f[^/R}hIM						ǉ
	RC4:(INV)RES	PIC -> GLCD	(INV)Zbg								ǉ

	ECZTƂ̒ʐMC^tF[X͂rohʐMB
	Ef[^Zbg̔F̓|[Oi荞ݗvtÔ݈pjB
	EʃVXeɂ͖{u璲ʐMőM̂݁B
	ECZT̓ɈˑēBf[^ZbggKƂēB
	EʐM̃rbg[gpɃ^C}Q𗘗pB
	EʐMx͂XUOOAWrbgApeB

	EOtBbNLCDƂ̒ʐMC^tF[X͂rohʐMB

*/

// ***************************************************************************
// *																 *
// ***************************************************************************

	//	*****  ***** PIC LF16F886 pɕύX

__CONFIG(	FCMDIS														//	tF[Z[tNbNj^֎~
		&	IESODIS														//	ONbÑXCb`I[o[[h֎~
		&	BORDIS														//	uEAEgo֎~
		&	MCLREN														//	MCLR[qL
		&	PWRTEN														//	p[Abv^C}싖
		&	WDTDIS														//	EHb`hbO^C}֎~
		&	LVPDIS														//@@dICSPvO~Ő֎~
		&	HS													    	//  OMiHS[hj
);
	//	***** hc *****

__IDLOC7(VER1, VER2, VER3, VER4);										//	o[WԍƂĒ`ïӖt͔CӁj

	//	***** U *****

#define	_XTAL_FREQ			8000000									//	giNbNpj@16F886 3.3VpɕύX

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************

	//	***** VAʐMx *****

#if 0
#define	COM_SPEED				(208 - 1)								//	 9600bps, 2000000/ 9600=208.333us/bit, 208 is -1.6%
#else
#define	COM_SPEED				(104 - 1)								//	19200bps, 2000000/19200= 104.167us/bit,  104 is -1.6%
#endif

// ***************************************************************************
// ***************************************************************************
// *	\																 *
// ***************************************************************************
// ***************************************************************************

	//	***** |[gf[^ *****

typedef	union {
	UB		BYTE;
	struct {															//								@l
		_UINT	MOSI	: 1;											//	OFMf[^				ó@O	kraFrbg̕тɒ
		_UINT	SCK		: 1;											//	PFNbN				ó@O
		_UINT	DRDY	: 1;											//	QFf[^Zbg			́@O
		_UINT	MISO	: 1;											//	RFMf[^				́@O
		_UINT	CSB		: 1;											//	SF`bvZNg			ó@P
		_UINT	TXD		: 1;											//	TFVAʐMMf[^	ó@P
		_UINT	_dummy6	: 1;											//	UFij				||@|
		_UINT	_dummy7	: 1;											//	VFij				||@|
	} BIT;
} uPort;

#define	SIG_DRDY				(BIT02)									//	Mǂݏo}XNpFf[^Zbg
#define	SIG_MISO				(BIT03)									//	Mǂݏo}XNpFMf[^

//								  76543210
#define	INIT_PORTA_DATA			0b00110000 								//	|[gf[^
#define	INIT_PORTA_DIR			0b00001100 								//	|[go͕ ύXiSW1̒ǉj
#define	INIT_PORTB_DIR			0b11110001 								//	|[go͕ ǉ

// ***************************************************************************
// ***************************************************************************
// *	O[oϐ														 *
// ***************************************************************************
// ***************************************************************************

uPort	vDevPort;														//	|[gf[^̃obNAbv

// ***************************************************************************
// ***************************************************************************
// *	e[u															 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	}N錾															 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	vg^Cv錾													 *
// ***************************************************************************
// ***************************************************************************

	//	***** M *****

void	DevSigPutMOSI_H(void);
void	DevSigPutMOSI_L(void);
void	DevSigPutSCK_H(void);
void	DevSigPutSCK_L(void);

UB		DevSigGetMISO(void);

	//	***** ʐM *****

void	DevComBrtStart(void);
void	DevComBrtStop(void);
void	DevComSendBit(UB Data);
void	DevComWaitSend(void);

// ***************************************************************************
// ***************************************************************************
// *	{															 *
// ***************************************************************************
// ***************************************************************************

//	
//	
//
// 		{
//
//	
//	
void	DevStd______(void) {}											//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ohb}CRݒ肵܂B
//			Zbg̏lōςޏꍇ͍Đݒ肵Ă܂B
//============================================================================
void	DevInit(void)
{
	//	***** { *****											//	ӁFȑÕTvvOɔ׃Rg̃rbg̕тt]Ă܂

	//	***** 荞݊ *****										//	f[^ZbgɂO荞ݑΉɔďݒ̂ݍs

//						  76543210
	INTCON = 			0b00000000;										//	荞ݐ䃌WX^i荞݋֎~Avj
																		//	bit00:GPIF		0	ėp̓|[gω荞ݖ		gp
																		//	bit01:INTF		0	O荞ݖ					
																		//	bit02:T0IF		0	^C}OI[ot[荞ݖ	gp
																		//	bit03:GPIE		0	ėp̓|[gω荞݋֎~		gp
																		//	bit04:INTE		0	O荞݋֎~					
																		//	bit05:T0IE		0	^C}OI[ot[荞݋֎~	gp
																		//	bit06:PEIE		0	ytF荞݋֎~			gp
																		//	bit07:GIE		0	Ă̊荞݋֎~					

	//	***** o̓|[g *****										//	ӁFĂ̏ꍇAėpo̓|[g͕ʋ@\Ă

	vDevPort.BYTE = INIT_PORTA_DATA;									//	ėpo̓|[gf[^̏lݒ
	PORTA = vDevPort.BYTE;												//	WX^ݒ

	ADCON1 = 0b00000111;												// @AiO̓|[gSăfW^I/O|[gɊtݒ肷iPORTAj@ǉ
	ANSEL  = 0b00000000;                                                //  ǉ
	ANSELH = 0b00000000;                                                //  ǉ
	TRISA  = INIT_PORTA_DIR;											//	PORTAo͕WX^
	TRISB  = INIT_PORTB_DIR;											//  PORTBo͕WX^ ǉ
}

//	
//	
//
// 		M
//
//	
//	
void	DevSig______(void) {}											//	op֐

//============================================================================
//	CZTւ̏o
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	CZTւ̐M𐧌䂵܂B
//============================================================================
void	DevSigPutMOSI_H(void)	{	vDevPort.BIT.MOSI = 1;		PORTA = vDevPort.BYTE;	}
void	DevSigPutMOSI_L(void)	{	vDevPort.BIT.MOSI = 0;		PORTA = vDevPort.BYTE;	}

void	DevSigPutSCK_H(void)	{	vDevPort.BIT.SCK  = 1;		PORTA = vDevPort.BYTE;	}
void	DevSigPutSCK_L(void)	{	vDevPort.BIT.SCK  = 0;		PORTA = vDevPort.BYTE;	}

void	DevSigPutCSB_H(void)	{	vDevPort.BIT.CSB  = 1;		PORTA = vDevPort.BYTE;	}
void	DevSigPutCSB_L(void)	{	vDevPort.BIT.CSB  = 0;		PORTA = vDevPort.BYTE;	}

//============================================================================
//	CZT̓
//----------------------------------------------------------------------------
//	́F	
//	óF	M̏ԁiOFkAOFgj
//----------------------------------------------------------------------------
//	lF	CZT̐M͂܂B
//============================================================================
UB		DevSigGetMISO(void)		{	return(PORTA & (UB)SIG_MISO);	}

//============================================================================
//	CZT̃f[^Zbg󋵂̎擾
//----------------------------------------------------------------------------
//	́F	
//	óF	f[^Zbg󋵁isqtd^e`krdj
//----------------------------------------------------------------------------
//	lF	CZTf[^łƂf[^ZbgM̗
//			GbW̌o󋵂擾܂B
//			M̗オGbWoꍇ̓NAs܂B
//============================================================================
BOOL	DevSigGetDRDY_Edge(void)
{
	UB		Result = FALSE;												//	ʂ̓GbW𖢌oŏ

	if (INTF) {														//	O荞 RB0(INT) ̗オGbWo
		INTF = 0;														//	oԂ
		Result = TRUE;													//	GbWoŃf[^Zbg
	}

	return(Result);														//	ʂԂ܂
}

//	
//	
//
// 		ʐM
//
//	
//	
void	DevCom______(void) {}											//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ʐMݒ肵܂B
//			rbg[g𓱂o߂Ƀ^C}Qgp܂B̃^C}Q̃^
//			CAEgԊuPrbgʐMԂɑ܂B
//============================================================================
void	DevComInit(void)
{
	//	***** rbg[g^C}ݒ *****

//			  76543210
	T2CON = 0b00000000;													//	^C}Q䃌WX^
																		//	bit00 T2CKPS0	0	vXP[͂PF1
																		//	bit01 T2CKPS1	0	@ij
																		//	bit02 TMR2ON	0	^C}Q~
																		//	bit03 TOUTPS0	0	|XgXP[͂PFP
																		//	bit04 TOUTPS1	0	@ij
																		//	bit05 TOUTPS2	0	@ij
																		//	bit06 TOUTPS3	0	@ij
																		//	bit07 -----

	PR2 = COM_SPEED;													//	sIhQWX^ݒ
}

//============================================================================
//	rbg[g^C}̓Jn
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	rbg[g^C}̓Jn܂B
//============================================================================
void	DevComBrtStart(void)
{
	TMR2ON	= 0;														//	^C}Q~

	TMR2	= 0;														//	^C}QNAivXP[A|XgXP[NAj
	TMR2IF	= 0;														//	^C}QvNA

	TMR2ON	= 1;														//	^C}Q
}

//============================================================================
//	rbg[g^C}̓~
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	rbg[g^C}̓~܂B
//============================================================================
void	DevComBrtStop(void)
{
	TMR2ON	= 0;														//	^C}Q~
}

//============================================================================
//	rbgf[^̑M
//----------------------------------------------------------------------------
//	́F	Mf[^ikrâ݁j
//	óF	
//----------------------------------------------------------------------------
//	lF	rbg[g^C}̃^CAEgmFAPrbg̃f[^𑗐M
//			܂Bn[hEFA^C}𗘗pĂ̂Œx̗ݐς͂܂B
//============================================================================
void	DevComSendBit(UB Data)
{
	//	***** ^CAEgmF *****

	while (TMR2IF == 0) ;												//	^C}Qv܂ŏ

	TMR2IF = 0;															//	^C}Qv

	//	***** PrbgM *****

	if (Data & (UB)BIT00) {												//	kra͂PH
		vDevPort.BIT.TXD  = 1;											//	gf[^
	}
	else {																//	kra͂O
		vDevPort.BIT.TXD  = 0;											//	kf[^
	}
	PORTA = vDevPort.BYTE;												//	WX^ݒ
}

//============================================================================
//	rbgf[^̑Mҋ@
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	Prbg̑Mҋ@܂B
//			񑗐M̍Ō̂PM̃Xgbvrbgێ܂B
//============================================================================
void	DevComWaitSend(void)
{
	while (TMR2IF == 0) ;												//	^C}Qv܂ŏ
}

//============================================================================
//	obt@̑M
//----------------------------------------------------------------------------
//	́F	obt@AhX
//	óF	
//----------------------------------------------------------------------------
//	lF	obt@Ɋi[镶R[h𒲕őM܂B
//			WrbgApeBAXgbvrbgPrbgŐ䂵܂B
//============================================================================
void	DevComSendData(const UB *Buffer)
{
	UB		SendData;													//	Mf[^
	UB		Loop;														//	[vJE^

	//	***** ͂߂ *****

	DevComBrtStart();													//	rbg[g^C}Jn	PrbgԑM͕ۗ܂

	//	***** 񑗐M *****

	while (*Buffer) {													//	񂪂ΑMp

		//	***** X^[grbgM *****

		SendData = 0;													//	X^[grbg͂k
		DevComSendBit(SendData);										//	rbgf[^̑M

		//	***** M *****

		SendData = *Buffer;												//	Mf[^擾
		Buffer ++;														//	obt@AhXXV

		//	***** WrbgM *****

		for (Loop=0; Loop<8; Loop++) {									//	WrbgJԂ
			DevComSendBit(SendData);									//	rbgf[^̑M
			SendData >>= 1;												//	̃rbgʒuɈړ
		}

		//	***** XgbvrbgM *****

		SendData = 1;													//	X^[grbg͂g
		DevComSendBit(SendData);										//	rbgf[^̑M
	}

	//	***** Xgbvrbg̑Mҋ@ *****

	DevComWaitSend();													//	rbgf[^̑Mҋ@

	//	***** ܂ *****

	DevComBrtStop();													//	rbg[g^C}̓~
}

//	
//	
//
// 		Ԑ
//
//	
//	
void	DevTim______(void) {}											//	op֐

//============================================================================
//	~bPʂ̑ҋ@
//----------------------------------------------------------------------------
//	́F	ҋ@ԁiO`QTTj
//	óF	
//----------------------------------------------------------------------------
//	lF	\tgEFA^C}𗘗pҋ@s܂B
//============================================================================
void	DevTimWaitMs(UB Time)
{
	while (Time --) {													//	ҋ@Ԃ菄
		__delay_ms(1);													//	Pҋ@
	}
}

//	
//	
//
// 		roh
//
//	
//	
void	DevSpi______(void) {}											//	op֐

	//	***** M *****

#define	mSpiClk_L()				DevSigPutSCK_L()						//	NbNMk								
#define	mSpiClk_H()				DevSigPutSCK_H()						//	NbNMg

#define	mSpiOut_L()				DevSigPutMOSI_L()						//	o̓f[^k								
#define	mSpiOut_H()				DevSigPutMOSI_H()						//	o̓f[^g

#define	mSpiIn()				DevSigGetMISO()							//	̓f[^iOAOŔfj

	//	***** Ԑ *****

#define	mSpiWaitTDS()								 					//	f[^ZbgAbvԁi̎ԑҋ@ANbNMgɐ؂ւj

#define	mSpiWaitTCH()								 					//	NbNMgێ
#define	mSpiWaitTCL()													//	NbNMkێ

//============================================================================
//	Mݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	rohʐMŎgpo͐Mݒ肵܂B
//			ΏۃfoCXIbr͏ʊ֐Ő䂵ĂB
//============================================================================
void	DevSpiInit(void)
{
	mSpiClk_L();														//	NbNMk
	mSpiOut_L();														//	o̓f[^Mk
}

//============================================================================
//	CӃrbg̑M
//----------------------------------------------------------------------------
//	́F	Mf[^
//	óF	
//----------------------------------------------------------------------------
//	lF	Mf[^̂lra珇ԂɃrbg̑Ms܂B
//			ΏۃfoCXIbr͏ʊ֐Ő䂵ĂB
//============================================================================
void	DevSpiPutData(UB Data)
{
	UB		Number = 8;													//	Mrbg

	//	***** M *****

	while (Number --) {													//	MrbgJԂ

		//	***** f[^o *****

		if (Data & (UB)0x80) {											//	lraPH
			mSpiOut_H();												//	o̓f[^g
		}
		else {															//	lraO
			mSpiOut_L();												//	o̓f[^k
		}
		mSpiWaitTDS();													//	ҋ@Ff[^ZbgAbv

		//	***** NbN *****

		mSpiClk_H();													//	NbNMg
		mSpiWaitTCH();													//	ҋ@FNbNg

		mSpiClk_L();													//	NbNMk
		mSpiWaitTCL();													//	ҋ@FNbNk

		//	***** ̃rbg *****

		Data <<= 1;														//	PrbgVtg
	}
}

//============================================================================
//	Wrbg̎M
//----------------------------------------------------------------------------
//	́F	
//	óF	Mf[^
//----------------------------------------------------------------------------
//	lF	Wrbg̃f[^lraMĕԂ܂B
//			ΏۃfoCXIbr͏ʊ֐Ő䂵ĂB
//============================================================================
UB		DevSpiGetData(void)
{
	UB		Number = 8;													//	Mrbg
	UB		Data = 0;													//	Mf[^

	//	***** M *****

	while (Number --) {													//	MrbgJԂ

		//	***** ̃rbg *****

		Data <<= 1;														//	PrbgVtg

		//	***** f[^ *****

		if (mSpiIn()) {													//	̓f[^͂gH
			Data |= (UB)0x01;											//	̍
		}
//*		mSpiWaitTDS();													//	ҋ@Ff[^ZbgAbv	{sv

		//	***** NbN *****

		mSpiClk_H();													//	NbNMg
		mSpiWaitTCH();													//	ҋ@FNbNg

		mSpiClk_L();													//	NbNMk
		mSpiWaitTCL();													//	ҋ@FNbNk
	}

	//	***** ܂ *****

	return(Data);														//	Mf[^Ԃ܂
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 PaletteSoft LLC

